/*								    *\
 invstrinv.c	versin 1.0	25 de octubre de 2005

 Este fichero define las funciones invstrinv() e iwcsinv() junto con
 los ficheros fun_invstrinv.h y Makefile . La utilizacin de estas
 funciones requiere el fichero invstrinv.h y se proporciona un
 programa de prueba test/test_invstrinv.c . La ayuda de uso de estas
 funciones la proporciona el fichero invstrinv.3 (que tiene unas
 condiciones de uso distintas).

 -----
 (c) Noel Torres, 2005
 * Se concede permiso para utilizar este cdigo, sin limitacin de
 fines, siempre que el cdigo resultante conceda, al menos, los mismos
 permisos que esta nota de Licencia.
 * Se concede permiso para enlazar el resultado binario de compilar
 este cdigo, sin limitacin de fines.
 * Se concede permiso para distribuir este cdigo o el resultado
 binario de su compilacin. Los receptores de dicha distribucin
 obtienen del Autor los permisos de esta Licencia, no ligados a los
 permisos del distribuidor. Si se distribuyere el resultado binario de
 este cdigo, debe proporcionarse con l ste cdigo o bien
 proporcionar al receptor un medio sin coste (o con el mero coste de
 material de la copia) para obtenerlo.
 * Se concede permiso para modificar este cdigo, sin limitacin de
 fines.
 * Se concede permiso para distribuir copias modificadas de este
 cdigo. Tal distribucin debe realizarse bajo otro nombre o bien
 indicando claramente que se trata de una versin no oficial de este
 cdigo. El cdigo modificado debe proporcionar a sus receptores, al
 menos, los mismos derechos que ste. En cualquier caso, debe
 informarse al receptor de la autora de este cdigo.
 * Si se distribuye este cdigo a gran escala, compilado o no,
 enlazado o no, modificado o no, se ruega informar al autor.
 * Si encuentra este cdigo til, piense en realizar un regalo a
 alguien que lo necesite ms que usted. Un simple paquete de arroz
 puede significar la diferencia entre la vida y la muerte para
 alguien.
 -----

\*								    */

#include <stdlib.h> /*malloc()*/
#include "fun_invstrinv.h" /* Este fichero define las macros
			fun_char , fun_invstrinv , fun_strlen y
			fun_cero para valer char , invstrinv , strlen
			o '\0' o sus equivalentes para caracteres
			anchos en funcin del valor de INVSTRINV_CHAR,
				      macro definida exteriormente. */

/*					   *\
 INVSTRINV_CHAR | 1         | 4
 ---------------+-----------+---------------
 fun_char       | char      | wchar_t
 fun_invstrinv  | invstrinv | iwcsinv
 fun_strlen     | strlen    | wcslen
 fun_cero       | '\0'      | (wchar_t)L'\0'
\*					   */

/*@null@*/ fun_char * fun_invstrinv(const fun_char* cadena) /*@*/
				/* La funcin (sea invstrinv() o
				iwcsinv() ) puede devolver un puntero
				nulo NULL y no modifica ninguna
						   variable global. */
{
 size_t tam;
 fun_char* cinversa;

 tam=fun_strlen(cadena);
 cinversa=malloc((tam+1)*sizeof(cinversa[0]));

 if (cinversa != NULL)
  {
   register size_t i;
   for (i=0;i<tam;i++)
   {
    cinversa[i]=cadena[tam-i-1];
   } /* endfor (i=0;i<tam;i++) */
   cinversa[tam]=fun_cero;
  } /* if (cinversa != NULL) */

 return(cinversa);
} /* Fin fun_invstrinv() */
